# Code for "Optimal Mitigation Policies in a Pandemic: Social Distancing and Working from Home"

by Callum Jones, Thomas Philippon, and Venky Venkateswaran

Last updated on 01-July-2021.

The paper is available [here](https://callumjones.github.io/files/covid.pdf).

## Software Requirements

- The code is written in Matlab.
- The [Dynare](https://www.dynare.org/) package is used to run the model simulations. The scripts work with version 4.6.0 of Dynare.

## Figures

The figures in the paper are computed by running the scripts below. All figures are printed to the `/output` folder.

| Figure File Name         | Script to Run               |
|--------------------------|-----------------------------|
|equilibrium_detvaccine    | `main_equilibrium`          |
|planner_detvaccine        | `main_planner`              |
|Vs_Vi                     | `main_Vs_Vi`                |
|twostates                 | `main_twostates`            |
|high_mortality            | `main_detvaccine_robustness`|
|no_congestion             | `main_detvaccine_robustness`|
|param_uncert_shorthorizon | `main_detvaccine_robustness`|
|param_uncert_longhorizon  | `main_detvaccine_robustness`|
|tv_death_rate_planner     | `main_planner_tvparams`     |
|tv_e0_planner             | `main_planner_tvparams`     |
|fatigue_baseline          | `main_fatigue`              |
|sector_bar                | `main_multisector_planner`  |
